sha512hmac(8)

NAME
sha512hmac - compute and check HMAC values

SYNOPSIS
sha512hmac [OPTIONS] [-u | -k keyfile | -K key] [-c file [-q] | file [...] ]

DESCRIPTION
The sha512hmac command can compute and/or verify HMAC and unkeyed checksum values for the contents of files. Variations such as sha384hmac, sha256hmac, and sha1hmac all operate similarly except that they use different digest algorithms.

SELF-TEST
As a safety measure, the tool will always attempt to verify a previously- computed HMAC over itself with the contents of a second file (sha512hmac.hmac for sha512hmac, and a similarly-named file for each variation) before processing any other files, and will exit with an error if the second file either cannot be read or does not match the computed value.

OPTIONS

-c  Check that the HMAC values and names listed in the specified file(s) are correct for the files which are available. The format of the files should match the output which the tool produces when computing the values: a hex-encoded HMAC value and then a filename, separated by whitespace.

-q  Suppress any output when checking values.

-d cfgdir
    Specify the configuration directory to be used by the NSS library. The default location is /etc/pki/nssdb.

-h algorithm
    Generate the HMAC value using a non-default hashing algorithm. The default is determined by the name used to invoke the tool (sha1hmac, sha256hmac, etc.). If no default can be derived this way, the default setting will be sha512. Specify help or another invalid value to obtain a list of recognized algorithms.

-u  Generate an unkeyed checksum instead of an HMAC. The output produced by the tool should then be comparable to that of sha1sum and related tools.

-k filename
    Use the contents of the specified file as the secret key used in computing the HMAC values. If no key file or text is specified, a hard-coded default value is used. This option should always be used.

-K text
    Use the text of the argument as the secret key used in computing the HMAC values. If no key file or text is specified, a hard-coded default value is used.

-t bits
    Truncate HMAC values to a given length when computing or verifying them.

-S  Generate an HMAC over the tool itself and output it on standard out. This is a bootstrapping option which is not expected to be used.

-P  Attempt to pass all input files through prelink -y before processing their contents. The tool always attempts to do so when computing or performing a self-check.

EXAMPLES
Example output from sha1hmac, for files on the developer's system:
  e64db5e8a9b8a40091e5302fa4de0bfc6c5d19d0 /etc/passwd
  e7d93a2c70ec4d7720c6f2b033c1e5ea19f2d677 /etc/group
  d732d6df77114ea6b81a43d64655f86b1e5ee925 /etc/services
  ad92162bef979054a75d1f3510e6b05902bec641 /etc/hosts

SEE ALSO
fipshmac(1), fipscheck(1), prelink(8)

BUGS
Probably, but let's hope not. If you find any, please either report them in the bug database at http://bugzilla.redhat.com/ against the "hmaccalc" component, or in the trac instance at https://fedorahosted.org/hmaccalc/.

AUTHOR
Nalin Dahyabhai <nalin@redhat.com>